const ICONID = 1;
const PATH = 2;
const STARTMONTH = 3;
const STARTDAY = 4;
const ENDMONTH = 5;
const ENDDAY = 6;
const CHECKSUM = 7

jOmnis.callbackObject = {
    index: null,
    logos: null,
    logoID: null,
    dataset: null,
    omnisOnLoad: function() {
        this.index = 0;
        this.logos = null;
        this.logoID = 0;
        this.dataset = false;
    },
    omnisSetData: function(logos) {
        this.logos = [];
        if (logos instanceof omnis_list && logos.getRowCount()>0) {
            this.dataset = true;
            for (var i = 0; i < logos.getRowCount(); i++) {
                var logo = {
                    id:             logos.getData(ICONID, i+1),
                    path:           logos.getData(PATH, i+1),
                    startMonth:     logos.getData(STARTMONTH, i+1),
                    startDay:       logos.getData(STARTDAY, i+1),
                    endMonth:       logos.getData(ENDMONTH, i+1),
                    endDay:         logos.getData(ENDDAY, i+1),
                    checksum:       logos.getData(CHECKSUM, i+1),
                    omnisLine:      i+1};

                if(isLogoValid(logo)){
                    this.logos.push(logo);
                    if(logos.getRowSelectionState(i+1)){
                        this.logoID = logo.id;
                        this.index = this.logos.length-1;
                    }
                }
                
            }
        }
    },
    recallLogo: function(logoSettings){
        this.logoID = recallLogoHelper(logoSettings,this.logoID,this.logos);
        var line = this.omnisGetCurrentLine();
        console.log("line: "+line)
        jOmnis.sendClickEvent(line);
        this.setLogo();
    },

    omnisGetCurrentLine: function(){
        var currentLogo = this.logos.find(x => x.id === this.logoID);
        if(currentLogo)
            return currentLogo.omnisLine;
        return 0;
    },
    setLogo: function(){
        if(this.logos.find(x => x.id === this.logoID)== undefined){
            this.logoID = 19988;
            jOmnis.sendClickEvent(this.omnisGetCurrentLine());
        }
        document.getElementById("logo").src=this.logos.find(x => x.id === this.logoID)["path"];
    },
    incrementLogo: function(){
        for(var i = 0; i<this.logos.length-1; i++){
            if(this.logoID == this.logos[i].id){
                this.index = i;
                break;
            }

        }
        if(this.index == (this.logos.length-1)){
            this.logoID = this.logos[0].id
            this.index = 0;
        }
        else{
            this.index = this.index+1;
            this.logoID = this.logos[this.index].id;
        }
        jOmnis.sendClickEvent(this.omnisGetCurrentLine());
    }
};


window.addEventListener("click", function(e) {
    if(e.shiftKey){
        jOmnis.callbackObject.incrementLogo();
        jOmnis.callbackObject.setLogo();
    }

});